




<!DOCTYPE html>
<html>
<head>
<title>在Qt中使用SQLite数据库 -  码上快乐</title>
<meta name="keywords" content="C++,Qt,SQLite,SQL" />
<meta name="description" content="前言 SQLite sql 是一款开源轻量级的数据库软件，不需要server，可以集成在其他软件中，非常适合嵌入式系统。 Qt 以上版本可以直接使用SQLite Qt自带驱动 。 用法 准备 引入SQL模块 在Qt项目文件 .pro文件 中，加入SQL模块： 引用头文件 在需要使用SQL的类定义中，" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<meta http-equiv="X-UA-Compatible" content="ie=edge">
<meta http-equiv="Cache-Control" content="no-transform" />
<meta http-equiv="Cache-Control" content="no-siteapp" />
<meta name="applicable-device" content="pc,mobile">
<link href="/css/all.css?version=" rel="stylesheet">
<link href="/css/prettify.css?version=" rel="stylesheet">
</head>
<body onload="prettyPrint()">
    
<style>
.div2{top:45px;z-index:999;position:fixed;_position:absolute}
</style>
<div class="navbar navbar-inverse navbar-fixed-top">
	<div class="navbar-inner">
		<div class="container">
			<button data-target=".nav-collapse" data-toggle="collapse" class="btn btn-navbar" type="button">
				<span class="icon-bar"></span> 
				<span class="icon-bar"></span>
				<span class="icon-bar"></span>
			</button>
			<a class="brand" href="/index.html">码上快乐</a>
			<div class="nav-collapse collapse">
                <p class="navbar-text pull-right toplogin" style="margin-top:0px;">
	              <a href="javascript:void(0)" class="btn-show-login navbar-link">1秒登录</a>
	            </p>		
				<ul class="nav">
					<li class="navtop index"><a href="/index.html"><i class="icon-home icon-white"></i><strong>首页</strong></a></li>
					<li class="navtop recent"><a href="/rank.html"><i class="icon-fire icon-white"></i><strong>榜单</strong></a></li>
					<li class="navtop tags"><a href="/tags.html"><i class="icon-tag icon-white"></i><strong>标签</strong></a></li>
					<li class="navtop hot"><a href="/about.html"><i class="icon-heart icon-white"></i><strong>关于</strong></a></li>
					<li class="navtop hot"><a href="javascript:void(0);" rel="nofollow"><i class="icon-fire icon-white"></i><strong style="color:red" class="gptclass"></strong></a></li>
				</ul>
			</div>
		</div>
	</div>
</div>
<script src="/js/all.js?version="></script>

<!-- Global site tag (gtag.js) - Google Analytics -->

    <input name="ua" value="" type="hidden"/>
    <input name="title" value="在Qt中使用SQLite数据库" type="hidden"/>
	<div class="container" style="padding-top:20px;">
		<div class="row-fluid m_b_20">
		    
			<div class="span2 visible-desktop" id="logo">
				<center>
					<a href="/index.html"><img src="/img/logo.png?version=" class="h_30"/></a>
				</center>
			</div>
			<div class="span6">
				<form class="form-search" action="/so" name="search-form">
					<div class="input-append span10">
						<center>
							<input type="text" class="span12 search-query" name="q" placeholder=" 请输入关键词搜索..." baiduSug="1">
							<button type="submit" class="btn btn-warning">搜索</button>
						</center>
					</div>
				</form>
			</div>
			<div class="span4 visible-desktop">
			    <a class="btn" href="/recommend/67dcb51/在Qt中使用SQLite数据库"><i class="icon-random"></i>相关内容</a>
			    &nbsp;&nbsp;<a class="btn" href="https://www.codeprj.com/blog/67dcb51.html"><i class="icon-refresh"></i>简体</a>
			    &nbsp;&nbsp;<a class="btn" href="https://www.codeprj.com/zh/blog/67dcb51.html"><i class="icon-refresh"></i>繁体</a>
				
			</div>
		</div>
		<div class="row-fluid">
		    
			<div class="span8">
			    <div class="content_div">
			      <center>
			      <h3><a href="/blog/67dcb51.html" style="color:black">在Qt中使用SQLite数据库</a></h3>
			      </center>
			      <div class="postinfo">
			              本文转载自
			      
			      <i class="icon-globe"></i>&nbsp;<a href="/go/aHR0cHM6Ly93d3cuY25ibG9ncy5jb20veGlhLXdlaXdlbi9wLzY4MDY3MDkuaHRtbA==" target="_blank">查看原文</a>
			      <i class="icon-time"></i>&nbsp;<span>2017-05-04 13:49</span>
			      <i class="icon-eye-open"></i>&nbsp;<span>66315&nbsp;</span>
                  
                     <i class="icon-tag"></i>&nbsp;
                     
                     
                     
                     <span><a href='/tag/C＋＋' target="_blank">C++</a>/</span>
                                          
                     
                     <span><a href='/tag/Qt' target="_blank">Qt</a>/</span>
                                          
                     
                     <span><a href='/tag/SQLite' target="_blank">SQLite</a>/</span>
                                          
                     
                     
                     <span><a href='/tag/SQL' target="_blank">SQL</a></span>                     
                     
                  
                  <i class="icon-star" title="56.1367"></i>
                  <i class="icon-star" title="56.1367"></i>
                  <i class="icon-star" title="56.1367"></i>
                  <i class="icon-star" title="56.1367"></i>
                  <i class="icon-star" title="56.1367"></i>                  
			      </div>
			      <hr/>
                 <div class="media-body" id="content_div">
                    <div class="title_down_ad ad">
					</div>
					<div class="post_content" id="postContent">
					  <h1 id="前言">前言</h1> 
<p>SQLite（sql）是一款开源轻量级的数据库软件，不需要server，可以集成在其他软件中，非常适合嵌入式系统。<br> Qt5以上版本可以直接使用SQLite（Qt自带驱动）。</p> 
<h1 id="用法">用法</h1> 
<h2 id="1-准备">1 准备</h2> 
<ol> 
 <li>引入SQL模块<br> 在Qt项目文件(.pro文件)中，加入SQL模块：</li> 
</ol> 
<pre><code>QT += sql
</code></pre> 
<ol start="2"> 
 <li>引用头文件<br> 在需要使用SQL的类定义中，引用相关头文件。例如：</li> 
</ol> 
<pre><code>#include &lt;QSqlDatabase&gt;
#include &lt;QSqlError&gt;
#include &lt;QSqlQuery&gt;
</code></pre> 
<h2 id="2-使用">2 使用</h2> 
<h3 id="1-建立数据库">1. 建立数据库</h3> 
<p>检查连接、添加数据库驱动、设置数据库名称、数据库登录用户名、密码。</p> 
<pre><code class="language-c++">QSqlDatabase database;
if (QSqlDatabase::contains("qt_sql_default_connection"))
{
    database = QSqlDatabase::database("qt_sql_default_connection");
}
else
{
    database = QSqlDatabase::addDatabase("QSQLITE");
    database.setDatabaseName("MyDataBase.db");
    database.setUserName("XingYeZhiXia");
    database.setPassword("123456");
}
</code></pre>
<ins class="adsbygoogle" style="display:block; text-align:center;" data-ad-layout="in-article" data-ad-format="fluid" data-ad-client="ca-pub-4353345653789615" data-ad-slot="4890554435"></ins>
<script>     (adsbygoogle = window.adsbygoogle || []).push({});</script> 
<p>上述代码解释：<br> （1）第一行中，建立了一个<code>QSqlDatabase</code>对象，后续的操作要使用这个对象。<br> （2）<code>if</code>语句用来检查指定的连接(connection)是否存在。这里指定的连接名称（connection name）是<code>qt_sql_default_connection</code>，这是Qt默认连接名称。实际使用时，这个名称可以任意取。如果判断此连接已经存在，那么<code>QSqlDatabase::contains()</code>函数返回true。此时，进入第一个分支，<code>QSqlDatabase::database()</code>返回这个连接。<br> （3）如果这个连接不存在，则进入<code>else</code>分支，需要创建连接，并添加数据库。在<code>else</code>分支第一行，<code>addDatabase()</code>的参数<code>QSQLITE</code>是SQLite对应的驱动名，不能改。而且需要注意的是，<code>addDatabase()</code>的第二个参数被省略了，第二个参数的默认参数就是上面提到的Qt默认连接名称<code>qt_sql_default_connection</code>。如果需要使用自定义的连接名称（如果程序需要处理多个数据库文件的话就会这样），则应该加入第二个参数，例如</p> 
<pre><code class="language-c++">database = QSqlDatabase::addDatabase("QSQLITE", "my_sql_connection);
</code></pre> 
<p>这个时候，如果在另一个地方需要判断<code>my_sql_connection</code>连接是否存在，就应该使用<code>if (QSqlDatabase::contains("my_sql_connection"))</code>。<br> （4）<code>else</code>分支第二行中，<code>setDatabaseName()</code>的参数是数据库文件名。如果这个数据库不存在，则会在后续操作时自动创建；如果已经存在，则后续的操作会在已有的数据库上进行。<br> （5）<code>else</code>分支后面两行，设置用户名和密码。用户名，密码都可以随便取，也可以省略。</p>
<ins class="adsbygoogle" style="display:block; text-align:center;" data-ad-layout="in-article" data-ad-format="fluid" data-ad-client="ca-pub-4353345653789615" data-ad-slot="4890554435"></ins>
<script>     (adsbygoogle = window.adsbygoogle || []).push({});</script> 
<h3 id="2-打开数据库">2. 打开数据库</h3> 
<p>使用<code>open()</code>打开数据库，并判断是否成功。注意，在第一步检查连接是否存在时，如果连接存在，则在返回这个连接的时候，会默认将数据库打开。</p> 
<pre><code class="language-c++">if (!database.open())
{
    qDebug() &lt;&lt; "Error: Failed to connect database." &lt;&lt; database.lastError();
}
else
{
    // do something
}
</code></pre> 
<p>如果打开成功，则进入else分支。对数据库的操作都需要在else分支中进行。</p> 
<h3 id="3-关闭数据库">3. 关闭数据库</h3> 
<p>数据库操作完成后，最好关闭。</p> 
<pre><code class="language-c++">    database.close();
</code></pre> 
<h3 id="4-操作数据库">4. 操作数据库</h3> 
<p>对数据库进行操作需要用到QSqlQuery类，操作前必须定义一个对象。下面举例说明操作方法。操作需要使用SQLite语句，本文中的几个例子会使用几个常用的语句，关于SQLite语句的具体信息请参考SQLite相关资料。<br> <strong>例1：创建表格</strong><br> 创建一个名为student的表格，表格包含三列，第一列是id，第二列是名字，第三列是年龄。</p>
<ins class="adsbygoogle" style="display:block; text-align:center;" data-ad-layout="in-article" data-ad-format="fluid" data-ad-client="ca-pub-4353345653789615" data-ad-slot="4890554435"></ins>
<script>     (adsbygoogle = window.adsbygoogle || []).push({});</script> 
<pre><code class="language-c++">QSqlQuery sql_query;
QString create_sql = "create table student (id int primary key, name varchar(30), age int)";
sql_query.prepare(create_sql);
if(!sql_query.exec())
{
    qDebug() &lt;&lt; "Error: Fail to create table." &lt;&lt; sql_query.lastError();
}
else
{
    qDebug() &lt;&lt; "Table created!";
}
</code></pre> 
<p>代码解释：<br> （1）第一行定义一个<code>QSqlQuery</code>对象。<br> （2）第二行是一个<code>QString</code>，其中的内容是SQLite语句。对数据库的操作，都是用SQLite的语句完成的，把这些指令以QString类型，通过<code>prepare</code>函数，保存在QSqlQuery对象中。也可将指令，以QString形式直接写在<code>exec()</code>函数的参数中，例如：</p> 
<pre><code class="language-c++">    sql_query.exec("create table student (id int primary key, name varchar(30), age int)");
</code></pre> 
<p>创建表格语句：<code>create table &lt;table_name&gt; (f1 type1, f2 type2,…);</code><br> <code>create table</code>是创建表格的语句，也可用大写<code>CREATE TABLE</code>；student是表格的名称，可以任意取；括号中是表格的格式，上述指令表明，表格中有三列，第一列的名称（表头）是id，这一列储存的数据类型是int，第二列名称是name，数据类型是字符数组，最多有30个字符（和char(30)的区别在于，varchar的实际长度是变化的，而char的长度始终是给定的值），第三列的名称是age，数据类型是int。<br> 如果<code>sql_query.exec()</code>执行成功，则创建表格成功。</p>
<ins class="adsbygoogle" style="display:block; text-align:center;" data-ad-layout="in-article" data-ad-format="fluid" data-ad-client="ca-pub-4353345653789615" data-ad-slot="4890554435"></ins>
<script>     (adsbygoogle = window.adsbygoogle || []).push({});</script> 
<p><strong>例2：插入数据</strong><br> 在刚才创建的表格中，插入一行数据。</p> 
<pre><code class="language-c++">QString insert_sql = "insert into student values (?, ?, ?)";
sql_query.prepare(insert_sql);
sql_query.addBindValue(max_id+1);
sql_query.addBindValue("Wang");
sql_query.addBindValue(25);
if(!sql_query.exec())
{
    qDebug() &lt;&lt; sql_query.lastError();
}
else
{
    qDebug() &lt;&lt; "inserted Wang!";
}
if(!sql_query.exec("INSERT INTO student VALUES(3, \"Li\", 23)"))
{
    qDebug() &lt;&lt; sql_query.lastError();
}
else
{
    qDebug() &lt;&lt; "inserted Li!";
}
</code></pre> 
<p>插入语句：<code>insert into &lt;table_name&gt; values (value1, value2,…);</code><br> <code>insert into</code>是插入语句，student是表格名称，values()是要插入的数据。这里，我们插入了2组数据。插入第一组数据的时候，用<code>addBindValue</code>来替代语句中的<code>?</code>，替代的顺序与<code>addBindValue</code>调用的顺序相同。插入第二组数据的时候，则是直接写出完整语句。</p> 
<p><strong>例3：更新数据（修改数据）</strong></p> 
<pre><code class="language-c++">QString update_sql = "update student set name = :name where id = :id";
sql_query.prepare(update_sql);
sql_query.bindValue(":name", "Qt");
sql_query.bindValue(":id", 1);
if(!sql_query.exec())
{
    qDebug() &lt;&lt; sql_query.lastError();
}
else
{
    qDebug() &lt;&lt; "updated!";
}
</code></pre> 
<p>语句：<code>update &lt;table_name&gt; set &lt;f1=value1&gt;, &lt;f2=value2&gt;… where &lt;expression&gt;;</code><br> 更新（修改）的语句是<code>update...set...</code>，其中student是表格名称，name是表头名称（即第二列），:name是待定的变量，where用于确定是哪一组数据，:id也是待定变量。<br> <code>bindValue(" ", " ")</code>函数用来把语句中的待定变量换成确定值。</p> 
<p><strong>例4：查询数据</strong><br> （1）查询部分数据</p> 
<pre><code class="language-c++">QString select_sql = "select id, name from student";
if(!sql_query.exec(select_sql))
{
    qDebug()&lt;&lt;sql_query.lastError();
}
else
{
    while(sql_query.next())
    {
        int id = sql_query.value(0).toInt();
        QString name = sql_query.value(1).toString();
        qDebug()&lt;&lt;QString("id:%1    name:%2").arg(id).arg(name);
    }
}
</code></pre> 
<p>语句<code>select &lt;f1&gt;, &lt;f2&gt;, ... from &lt;table_name&gt;;</code><br> select是查询指令；<code>&lt;f1&gt;</code> 等等是要查询的变量（即表头），中间用逗号隔开；from ...指定表格。<br> 上述语句是说查询student表中的 id 和 name 。执行查询之后，用<code>sql_query.value(int)</code>来获得数据。同样地，<code>value(0)</code>表示第一个数据，即 id，<code>value(1)</code>表示name。<strong>注意</strong>：<code>value()</code>函数的返回值类型是<code>QVariant</code>，因此要用<code>toInt()</code>等函数转换成特定的类型。<br> （2）查询全部数据</p> 
<pre><code class="language-c++">QString select_all_sql = "select * from student";
sql_query.prepare(select_all_sql);
if(!sql_query.exec())
{
    qDebug()&lt;&lt;sql_query.lastError();
}
else
{
    while(sql_query.next())
    {
        int id = sql_query.value(0).toInt();
        QString name = sql_query.value(1).toString();
        int age = sql_query.value(2).toInt();
        qDebug()&lt;&lt;QString("id:%1    name:%2    age:%3").arg(id).arg(name).arg(age);
    }
}
</code></pre> 
<p>语句<code>select * from &lt;table_name&gt;;</code><br> 查询所有数据用 * 表示。用<code>while(sql_query.next())</code>用来遍历所有行。同样用<code>value()</code>获得数据。<br> （3）查询最大id</p> 
<pre><code class="language-c++">QString select_max_sql = "select max(id) from student";
int max_id = 0;
sql_query.prepare(select_max_sql);
if(!sql_query.exec())
{
    qDebug() &lt;&lt; sql_query.lastError();
}
else
{
    while(sql_query.next())
    {
        max_id = sql_query.value(0).toInt();
        qDebug() &lt;&lt; QString("max id:%1").arg(max_id);
    }
}
</code></pre> 
<p>这个就是在语句中用<code>max</code>来获取最大值。</p> 
<p><strong>例5：删除与清空</strong><br> （1）删除一条数据</p> 
<pre><code class="language-c++">QString delete_sql = "delete from student where id = ?";
sql_query.prepare(delete_sql);
sql_query.addBindValue(0);
if(!sql_query.exec())
{
    qDebug()&lt;&lt;sql_query.lastError();
}
else
{
    qDebug()&lt;&lt;"deleted!";
}
</code></pre> 
<p>语句<code>delete from &lt;table_name&gt; where &lt;f1&gt; = &lt;value&gt;</code><br> delete用于删除条目，用where给出限定条件。例如此处是删除 id = 0的条目。<br> （2）清空表格（删除所有）</p> 
<pre><code class="language-c++">QString clear_sql = "delete from student";
sql_query.prepare(clear_sql);
if(!sql_query.exec())
{
    qDebug() &lt;&lt; sql_query.lastError();
}
else
{
    qDebug() &lt;&lt; "table cleared";
}
</code></pre> 
<p>这里没有用where给出限制，就会删除所有内容。</p>
					</div>      
                    <div class="read-more" id="read-more" style="display:none"></div>        
                    <div class="alert alert-info" style="margin-top:20px;">
				      <p id="tips_top1">
				      </p>
			        </div>
			        <script type="text/javascript">
			         $("#tips_top1").append("<strong><i class=\"icon-fire\"></i>温馨提示：</strong>如果本文未解决您的问题，可以免费向大模型提问：<strong><a href='javascript:void(0)' class='gptbtn'>向AI大模型提问</a></strong>。");
			        </script>				        
					<div class="iframe-container">
					</div>
                 </div>
                 
			      
			      <div class="ad_content_down ad">
			      </div>                 
			    </div>
			     
			     <div class="disclaimer visible-desktop">
			         <br/>
		             <div class="alert alert-block">
		              <button type="button" class="close" data-dismiss="alert">×</button>
		              <h4>免责声明！</h4>
		                 <p>本站转载的文章为个人学习借鉴使用，本站对版权不负任何法律责任。如果侵犯了您的隐私权益，请联系本站邮箱yoyou2525@163.com删除。</p>
		            </div>	
		            <br/><br/>
                 </div>
			</div>
			
			<!-- 右边相关博客和资料 -->
			<div class="span4 left_content">
			  <div id="left_list_div" class="left_content">
			   <span class="list-group-item" href="javascript:void(0)"><i class="icon-filter"></i><strong>猜您在找</strong></span>
			   
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/bc7dba1.html" title="Qt使用SQLite数据库的基本步骤">
			           
			           <i class="icon-file"></i>
			           Qt使用SQLite数据库的基本步骤
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/29f6fe1.html" title="关于Qt sqlite数据库的使用总结">
			           
			           <i class="icon-file"></i>
			           关于Qt sqlite数据库的使用总结
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/50e0961.html" title="在Java中使用Sqlite数据库">
			           <i class="icon-fire"></i>
			           
			           在Java中使用Sqlite数据库
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/b0c1d41.html" title="SQLite in Python: 如何在Python中使用SQLite数据库">
			           
			           <i class="icon-file"></i>
			           SQLite in Python: 如何在Python中使用SQLite数据库
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/daa1901.html" title="Qt5使用QSqlQuery读写sqlite3数据库">
			           
			           <i class="icon-file"></i>
			           Qt5使用QSqlQuery读写sqlite3数据库
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/8f9b6b1.html" title="关于.Net中使用SQLite数据库的方法">
			           <i class="icon-fire"></i>
			           
			           关于.Net中使用SQLite数据库的方法
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/4caafb1.html" title="Go语言中使用SQLite数据库">
			           <i class="icon-fire"></i>
			           
			           Go语言中使用SQLite数据库
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/3f68be1.html" title="在Windows Phone 8.1中使用Sqlite数据库">
			           
			           <i class="icon-file"></i>
			           在Windows Phone 8.1中使用Sqlite数据库
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/46c5f21.html" title="[原创] Xcode中使用sqlite3访问数据库">
			           
			           <i class="icon-file"></i>
			           [原创] Xcode中使用sqlite3访问数据库
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/91cf8b1.html" title="Go语言中使用SQLite数据库">
			           
			           <i class="icon-file"></i>
			           Go语言中使用SQLite数据库
			           </a>
			       			       
			   
			   
			   <div id="right_float_ad" class="ad">
				</div>
			</div>
			</div>
		</div>
	</div>
    <div class="clear">&nbsp;</div>
    



<div class="fbar" style="z-index:100">
	<div class="span7" style="color:grey;font-size:12px;">
	</div>
	<div class="pull-right">
		<span><a href="http://beian.miit.gov.cn" rel="nofollow" target="_blank">粤ICP备18138465号</a>&nbsp;&nbsp;</span><span>&copy; 2018-2024 CODEPRJ.COM </span> 
	</div>
</div>
<script src="/js/code.js?version=20240328"></script>
<script>
   function buffer(a, b, c) {
	    var d;
	    return function() {
	        if (d) return;
	        d = setTimeout(function() {
	            a.call(this),
	            d = undefined
	        },
	        b)
	    }
	} 

	(function() {
	    function e() {
	        var d = document.body.scrollTop || document.documentElement.scrollTop;
	        d > b ? (a.className = "div1 div2", c && (a.style.top = d - b + "px")) : a.className = "div1"
	    }
	    var a = document.getElementById("float");
	    if (a == undefined) return ! 1;
	    var b = 0,
	    c, d = a;
	    while (d) b += d.offsetTop,
	    d = d.offsetParent;
	    c = window.ActiveXObject && !window.XMLHttpRequest;
	    if (!c || !0) window.onscroll = buffer(e, 50, this)
	})(); 

</script>

<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?85c5e8e7b6167edfc87cb0607142e870";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

    
    
</body>
</html>